IMPLEMENTATION MODULE PATRICIA;

FROM InOut   IMPORT Read,WriteString,WriteLn;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;
FROM Strings IMPORT Length;

TYPE
    C       = ARRAY [0..160] OF [0..1];
    bitkey  = [1..256];
    tree    = POINTER TO element;
    element = RECORD
                  type   : BOOLEAN;
                  Root   : tree;
                  in     : bitkey;
                  left,
                  right  : tree;
                  out    : key
              END;

VAR
    A             : C;
    searchelp,
    searchschlepp : tree;
    impossible    : BOOLEAN;

(*********************************************************)
(*       Umwandlung der Buchstaben des Schluessels       *)
(*         x in entsprechende Bit-Darstellung            *)
(*********************************************************)

PROCEDURE bitconversion (x : key);

VAR
    m,n,o,p,q,v,z : [1..160];
    B             : ARRAY [1..9] OF [0..1];
    help          : [1..256];

BEGIN
    FOR n := 1 TO 160 DO (* Zeichenkette A auf 0 setzten *)
        A[n] := 0
    END;
    n := 1;    o := 0;    p := 0;    z := 7;
    FOR q := 0 TO (Length (x) - 1) DO
        help := ORD (x[q]);
        IF ((help >= 32) AND (help <= 63)) THEN    
            A [o] := 0;       (* es werden nur 6 Bit     *)
            A [o + 1] := 0;   (* benoetigt; die ersten 2 *)
            p := p + 2        (* werden auf 0 gesetzt    *)
        ELSIF ((help >= 64) AND (help <= 127)) THEN
            A [o] := 0;            (* hier sind es 7 Bit *)
            p := p + 1;
        END;
        REPEAT                     (* in dieser Schleife *)
            IF help MOD 2 = 0 THEN (* findet die Berech- *)
                B [n] := 0         (* nung statt         *)
            ELSE
                B[n] := 1
            END;
            help := help DIV 2;
            n := n + 1;
        UNTIL help = 0;
        v := n - 1;
        FOR m := p TO z DO         (* das Ergebnis wird  *)
            A [m] := B [v];        (* in A gespeichert   *)
            v := v - 1;
        END;
        o := o + 8;
        p := o;
        n := 1;
        z := z + 8
    END
END bitconversion;

(*********************************************************)
(*   ueberprueft ob Element x im Baum enthalten ist      *)
(*********************************************************)

PROCEDURE search (e : tree; x : key) : BOOLEAN;

VAR
    flag          : BOOLEAN;
    bitposition   : [1..160];
    help          : BOOLEAN;

BEGIN
    bitconversion (x);
    searchelp := e^.Root;
    bitposition := searchelp^.in;
    flag := TRUE;
    (* in der Schleife wird 'shelp'auf das zu suchende   *)
    (* element gesetzt. 'sschlepp' laeuft einen Knoten   *)
    (* hinterher:                                        *)
    REPEAT
        IF A[bitposition] = 0 THEN
            searchschlepp := searchelp;
            searchelp := searchelp^.left
        ELSE
             searchschlepp := searchelp;
             searchelp := searchelp^.right
        END;
        IF searchelp^.type THEN
             bitposition := searchelp^.in
        ELSE
             flag := FALSE
        END;
    UNTIL NOT flag;
    help := Compare (searchelp^.out,x);
    IF help THEN                   (* ist Blatt gleich   *)
        RETURN TRUE                (* Schluessel x ?     *)
    ELSE                           (* JA => search = TRUE*)
        RETURN FALSE
    END;
END search;

(*********************************************************)
(*          einfuegen des Elementes x in den Baum        *)
(*********************************************************)

PROCEDURE insertelement (VAR e:tree; x:key);

VAR
    y           : key;
    B           : C;
    flag,
    position,
    bitposition : CARDINAL;
    helpnew,
    help,
    helpschlepp : tree;
    ein         : CHAR;

  (*******************************************************)
  (*       fuegt Element x hinter letztem Knoten an      *)
  (*******************************************************)
    PROCEDURE outinsert;

    BEGIN
         NEW (help);               (* hinter letztem     *)
         help^.in := position;     (* Element angefuegt  *)
         help^.type := TRUE;
         NEW (helpnew);            (* Erzeugung Blatt    *)
         helpnew^.type := FALSE;
         helpnew^.out := x;
         IF B[position] = 0 THEN
              help^.left := helpnew;
              help^.right := searchelp
         ELSE
              help^.left := searchelp;
              help^.right := helpnew
         END;
         IF B[searchschlepp^.in] = 0 THEN
             searchschlepp^.left := help
         ELSE
             searchschlepp^.right := help
         END
    END outinsert;

  (*******************************************************)
  (*        fuegt x als inneren Knoten im Baum ein       *)
  (*******************************************************)

    PROCEDURE ininsert;

    VAR
        helpme : tree;
        ein    : CHAR;

    BEGIN
        helpme := e^.Root;         (* neuen Knoten inner-*)
        bitposition := helpme^.in; (* halb des Baumes an-*)
        REPEAT                     (* gefuegt werden     *)
            IF B[bitposition] = 0 THEN
                helpschlepp := helpme;
                helpme := helpme^.left
            ELSE
                helpschlepp := helpme;
                helpme := helpme^.right
            END;
            flag := helpme^.in;
            bitposition := flag;
        UNTIL (flag > position) OR (flag = position);
        IF flag > position THEN
            NEW (help);            (* Erzeugung innerer  *)
            help^.type := TRUE;    (* Knoten             *)
            help^.in := position;
            IF B[helpschlepp^.in] = 0 THEN
                helpschlepp^.left := help
            ELSE
                helpschlepp^.right := help
            END;
            NEW (helpnew);         (* Erzeugung Blatt    *)
            helpnew^.type := FALSE;
            helpnew^.out := x;
            IF B[position] = 0 THEN
                help^.left := helpnew;
                help^.right := helpme
            ELSE
                help^.left := helpme;
                help^.right := helpnew
            END
        ELSE
           position := position + 1;
           position := bitcomparison (A,B,position);
           IF (NOT impossible) THEN
               outinsert
           ELSE
               WriteString ('ERROR: ');
               WriteString ('impossible to insert key ');
               WriteString (x);
               WriteLn;
               WriteString ('cannot find different bit!');
               WriteLn;
               WriteString ('please hit any key');
               Read (ein);
               WriteLn
           END
        END
    END ininsert;

  (*******************************************************)

BEGIN
    bitconversion (x);
    IF (search (e,x)) THEN
        WriteString ('ERROR: element already exists!');
        WriteLn;
        WriteString ('please hit any key');
        Read (ein)
    ELSIF (Compare(searchelp^.out,"0990")) THEN
        NEW (helpnew);             (* x kann direkt      *)
        helpnew^.type := FALSE;    (* hinter der Wurzel  *)
        helpnew^.out := x;         (* eingefuegt werden  *)
        IF A[0] = 0 THEN
            DISPOSE (searchschlepp^.left);   (* links    *)
            searchschlepp^.left := helpnew   (* anfuegen *)
        ELSE
            DISPOSE (searchschlepp^.right);  (* rechts   *)
            searchschlepp^.right := helpnew  (* anfuegen *)
        END
    ELSE
        y := searchelp^.out;
        B := A;            (* in B steht bitdarstellung  *)
        bitconversion (y); (* von x, in A von .out       *)
        position := bitcomparison (B,A,1);
        IF position > searchschlepp^.in THEN
            outinsert
        ELSE
            ininsert
        END
    END
END insertelement;

(*********************************************************)
(*                 Neuaufbau eines Baumes                *)
(*********************************************************)

PROCEDURE initialise (VAR e:tree);

VAR
    help : tree;

BEGIN
    NEW (e);
    e^.Root := e;
    e^.in := 0;
    e^.type := TRUE;
    NEW (help);                     (* Erzeugung innerer *)
    help^.type :=FALSE;             (* Knoten.           *)
    help^.out := "0990";            (* dient zur Identi- *)
    e^.left := help;                (* fizierung: 0990   *)
    NEW (help);                     (* => kann geloescht *)
    help^.type := FALSE;            (* werden            *)
    help^.out := "0990";
    e^.right := help;
    e^.type := TRUE;
END initialise;

(*********************************************************)
(*        Loeschen des Elementes x aus dem Baum e        *)
(*********************************************************)

PROCEDURE deleteelement (VAR e:tree; x:key);

VAR
    B        : C;
    position : [1..160];
    label    : CHAR;
    help,
    helpnew  : tree;
    flag     : BOOLEAN;

BEGIN
    IF NOT search (e,x) THEN
        WriteString ('ERROR: element not found, ');
        WriteString ('cannot delete this item !');
        WriteLn;
        WriteString ('please hit <RETURN>');
        Read (label)
    ELSIF searchschlepp^.Root = searchschlepp THEN
        DISPOSE (searchelp);   (* x direkt hinter wurzel *)
        NEW (searchelp);           (* nach loeschen zur  *)
        searchelp^.type := FALSE;  (* Identifizierung :  *)
        searchelp^.out := "0990";  (* 0990  s.Initialise *)
        IF A[0] = 0 THEN
            searchschlepp^.left := searchelp
        ELSE
            searchschlepp^.right := searchelp
        END
    ELSE
        flag := FALSE;
        help := e^.Root;
        REPEAT
            IF A[help^.in] = 0 THEN
                helpnew := help;
                help := help^.left
            ELSE
                helpnew := help;
                help := help^.right
            END;
            flag := (help = searchschlepp);
        UNTIL flag;
        IF A[help^.in] = 0 THEN
            help := help^.right
        ELSE
            help := help^.left
        END;
        IF A[helpnew^.in] = 0 THEN
            helpnew^.left := help
        ELSE
            helpnew^.right := help
        END;
        DISPOSE (searchelp);
        DISPOSE (searchschlepp);
        searchschlepp := help
    END
END deleteelement;

(*********************************************************)
(*           in welchem Bit unterscheidet sich           *)
(*             Schluessel x von Schluessel y ?           *)
(*********************************************************)

PROCEDURE bitcomparison (a,b:C;n:CARDINAL) : CARDINAL;

BEGIN
    LOOP
        IF (n = 161) OR (a[n] <> b[n])THEN
            EXIT
        END;
        n := n + 1
    END;
    IF n < 161 THEN
        impossible := FALSE
    ELSE
        impossible := TRUE
    END;
    RETURN (n)
END bitcomparison;

(*********************************************************)
(*   ueberprueft Zeichenkette x mit Zeichenkette y auf   *)
(*                    Gleichheit                         *)
(*              Ergebnis = TRUE  { x = y }               *)
(*              Ergebnis = FALSE { x <> y }              *)
(*********************************************************)

PROCEDURE Compare (a,b : key) : BOOLEAN;

VAR
    n    : [1..20];

BEGIN
    IF Length (a) <> Length (b) THEN
        RETURN FALSE
    ELSE
        FOR n := 1 TO Length (a) DO
            IF (a[n] <> b[n]) THEN
                RETURN FALSE
            END
        END
    END;
    RETURN TRUE
END Compare;

(*************************************************************************)

BEGIN
END PATRICIA.
