/*--------------------------------------------------------*/
/*                      SCRSAVE.H                         */
/*          Prototypen und Defines von SCRSAVE.C          */
/*          Mit Turbo Prolog linkfhige Routinen          */
/*          (C) M.Schlter & PASCAL INTERNATIONAL         */

/* Der Bildschirmspeicher der CGA-Karte ist in zwei 8000
   Byte groen Halbseiten organisiert. Die Seite 0 liegt
   auf der Adresse B800h:0000h, die Seite 1 auf der
   Adresse B800h:2000h.                                   */
#define SCRBASE 0xB800
#define PAGE0OFF 0
#define PAGE1OFF 0x2000
#define PAGESIZE 8000

/* Anhngen der '_0' Suffixe geschieht bei nicht defi-
   nierten 'TEST' automatisch. Gleichfalls wird der
   "_"-Prfix fr den Zugriff auf die C-Library auto-
   matisch vornean gestellt.                              */
#ifndef TEST
#  define save_screen save_screen_0
#  define load_screen load_screen_0
#  define open _open
#  define write _write
#  define read _read
#  define close _close
#endif

/* Prototypen der beiden Funktionen */
void save_screen(char *, int *);
void load_screen(char *, int *);
