(* --------------------------------------------------- *)
(*                   LISTMOD.DEF                       *)
(*         Definitons-Modul des Listen-Moduls          *)

DEFINITION MODULE ListMod;

FROM SYSTEM IMPORT ADDRESS;

TYPE ListType;           (* abstrakter Datentyp !! *)

ListPositionProc = PROCEDURE (ADDRESS,ADDRESS) : BOOLEAN;
ListTraverseProc = PROCEDURE (ADDRESS);


PROCEDURE LIstOpen         (VAR L : ListType;
                            RecordLaenge : CARDINAL);
PROCEDURE LIstClose        (VAR L : ListType);


PROCEDURE EmptyLIst        (L : ListType) : BOOLEAN;
PROCEDURE HeadOfLIst       (L : ListType) : BOOLEAN;
PROCEDURE TailOfLIst       (L : ListType) : BOOLEAN;
PROCEDURE LengthOfLIst     (L : ListType) : CARDINAL;


PROCEDURE LIstHead         (L : ListType);
PROCEDURE LIstTail         (L : ListType);
PROCEDURE LIstSavePosition (L : ListType;
                            VAR aktPointer : ADDRESS);
PROCEDURE LIstLoadPosition (L : ListType;
                            aktPointer : ADDRESS);


PROCEDURE LIstCurrent      (L : ListType;
                            VAR Info : ADDRESS);
PROCEDURE LIstNext         (L : ListType);
PROCEDURE LIstPrev         (L : ListType);


PROCEDURE LIstDelete       (L : ListType);
PROCEDURE LIstAppend       (L : ListType;
                            Info : ADDRESS);
PROCEDURE LIstInsert       (L : ListType;
                            Info : ADDRESS);


PROCEDURE LIstSearchToTail(L          : ListType;
                           Position   : ListPositionProc;
                           Vergleich  : ADDRESS;
                           VAR gefunden     : BOOLEAN);
PROCEDURE LIstSearchToHead(L          : ListType;
                           Position   : ListPositionProc;
                           Vergleich  : ADDRESS;
                           VAR gefunden     : BOOLEAN);
PROCEDURE LIstFromHeadToTail(L            : ListType;
                        ListTraverse : ListTraverseProc);
PROCEDURE LIstFromTailToHead(L            : ListType;
                        ListTraverse : ListTraverseProc);


PROCEDURE ListOpen       (VAR L : ListType;
                          RecordLaenge : CARDINAL);
PROCEDURE ListClose;
PROCEDURE ListDefault    (VAR L : ListType);


PROCEDURE EmptyList        () : BOOLEAN;
PROCEDURE HeadOfList       () : BOOLEAN;
PROCEDURE TailOfList       () : BOOLEAN;
PROCEDURE LengthOfList     () : CARDINAL;


PROCEDURE ListHead;
PROCEDURE ListTail;
PROCEDURE ListSavePosition (VAR aktPointer : ADDRESS);
PROCEDURE ListLoadPosition (    aktPointer : ADDRESS);


PROCEDURE ListCurrent       (VAR Info : ADDRESS);
PROCEDURE ListNext;
PROCEDURE ListPrev;


PROCEDURE ListDelete;
PROCEDURE ListAppend        (     Info : ADDRESS);
PROCEDURE ListInsert        (     Info : ADDRESS);


PROCEDURE ListSearchToTail(Position   : ListPositionProc;
                           Vergleich  : ADDRESS;
                           VAR gefunden     : BOOLEAN);
PROCEDURE ListSearchToHead(Position   : ListPositionProc;
                           Vergleich    : ADDRESS;
                           VAR gefunden     : BOOLEAN);
PROCEDURE ListFromHeadToTail(
                        ListTraverse : ListTraverseProc);
PROCEDURE ListFromTailToHead (
                        ListTraverse : ListTraverseProc);


END ListMod.
