(* ------------------------------------------------------ *)
(*                    CONDEMO.PAS                         *)
(*     Demonstrationsprogramm zur Unit CONINPUT.PAS       *)
(* ------------------------------------------------------ *)
PROGRAM ConInputDemo;

USES
  Crt, ConInput;

CONST
  S : STRING  = 'Diese Zeichenkette kann gescrollt werden!';
  L : LONGINT = 123456;
  R : REAL    = 3.141593;

PROCEDURE Inform (Message : STRING);
BEGIN
  TextAttr := $0F;
  GotoXY ((80-Length(Message)) DIV 2, 25);
  DelLine; Write (Message);
END;

PROCEDURE OpenWindow (Col,Row,Len,Attr : BYTE);
VAR
  k : BYTE;
BEGIN
  TextAttr := Attr;
  GotoXY (Col,Row  ); Write(#218);
  FOR k:=1 TO Len DO Write(#196); Write(#191);
  GotoXY (Col,Row+1); Write(#179);
  FOR k:=1 TO Len DO Write(#032); Write(#179);
  GotoXY (Col,Row+2); Write(#192);
  FOR k:=1 TO Len DO Write(#196); Write(#217);
  GotoXY (Col+2,Row+1);
END;

BEGIN
  ClrScr;

  Inform ('Einlesen einer horizontal scrollbaren '+
          'Zeichenkette mit Vorgabe');
  OpenWindow ( 5, 5,42,$70);
  EditSize := 40;
  ReadString (S);

  Inform ('Einlesen einer LONGINT-Variablen mit '+
          'Begrenzung auf 6 Stellen');
  OpenWindow (10,10,10,$1F);
  BufLen := 6;
  ReadLongInt (L);

  Inform ('Einlesen einer REAL-Variablen ohne Vorgabe');
  OpenWindow (15,15,22,$70);
  EditOld := FALSE;
  BufLen := 255;
  EditSize := 20;
  ReadReal (R);

  Inform ('Editieren der letzten REAL-Variablen mit '+
          'Vorgabe im Fixkommaformat');
  OpenWindow (20,20,22,$70);
  Decimals := 6;
  EditOld := TRUE;
  ReadReal (R);

  Inform ('');
END.
(* ------------------------------------------------------ *)
(*               Ende von CONDEMO.PAS                     *)